<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>11.2 Freeing Memory</title>
<link href="sx11a.html" rev=precedes>
<link href="sx11c.html" rel=precedes>
<link href="sx11.html" rev=subdocument>
</head>
<body>
<H2>11.2 Freeing Memory</H2>

<p>Memory allocated with <TT>malloc</TT>
lasts as long as you want it to.
It does not automatically disappear when a function returns,
as automatic-duration variables do,
but it does not have to remain
for the entire duration of your program,
either.
Just as you can use <TT>malloc</TT> to control
exactly when and how much memory you allocate,
you can also control exactly when you deallocate it.
</p><p>In fact,
many programs use memory on a transient basis.
They allocate some memory, use it for a while,
but then reach a point where they don't need that particular piece any more.
Because memory is not inexhaustible,

it's a good idea to
deallocate
(that is,
release or <dfn>free</dfn>)
memory you're no longer using.
</p><p>Dynamically allocated memory is deallocated with
the <TT>free</TT> function.
If <TT>p</TT> contains a pointer previously returned by <TT>malloc</TT>,
you can call
<pre>
	free(p);
</pre>
which will ``give the memory back'' to the stock of memory
(sometimes called the ``arena'' or ``pool'')
from which <TT>malloc</TT> requests are satisfied.
Calling <TT>free</TT> is sort of the ultimate in recycling:
it costs you almost nothing,
and the memory you give back is immediately usable
by other parts of your program.
(Theoretically, it may even be usable by other programs.)
</p><p>(Freeing unused memory is a good idea,
but it's not mandatory.
When your program exits,
any memory which it has allocated but not freed
should be automatically released.
If your computer were to somehow ``lose'' memory
just because your program forgot to free it,
that would indicate a problem or deficiency in your operating system.)
</p><p>Naturally,
once you've freed some memory
you must remember not to use it any more.
After calling
<pre>
	free(p);
</pre>
it is probably the case
that <TT>p</TT>
still points at the same memory.
However, since we've given it back,
it's now ``available,''
and
a later call to <TT>malloc</TT> might give that memory
to some other part of your program.
If the variable <TT>p</TT> is a global variable
or will otherwise stick around for a while,
one good way to record the fact that it's not to be used any more
would be to set it to a null pointer:
<pre>
	free(p);
	p = NULL;
</pre>
Now we don't even have the pointer to the freed memory any more,
and
(as long as we check to see that <TT>p</TT> is non-<TT>NULL</TT>
before using it),
we won't misuse any memory via the pointer <TT>p</TT>.
</p><p>When thinking about <TT>malloc</TT>,
<TT>free</TT>,
and dynamically-allocated memory in general,
remember again the distinction between a pointer and what it points to.
If you call <TT>malloc</TT> to allocate some memory,
and store the pointer which <TT>malloc</TT> gives you in a 
local pointer variable,
what happens when the function containing the local pointer 
variable returns?
If the local pointer variable has <dfn>automatic duration</dfn>
(which is the default,
unless the variable is declared <TT>static</TT>),
it will disappear when the function returns.
But for

the pointer variable to disappear says nothing about
the memory pointed to!
That memory still exists and,
as far as <TT>malloc</TT> and <TT>free</TT> are concerned,
is still allocated.
The only thing that has disappeared
is the pointer variable you had
which pointed at the allocated memory.
(Furthermore,
if it contained the only copy of the pointer you had,
once it disappears,
you'll have no way of freeing the memory,
and no way of using it, either.
Using memory
and freeing memory
both
require that you have at least one pointer to the memory!)
</p><hr>
<p>
Read sequentially:
<a href="sx11a.html" rev=precedes>prev</a>
<a href="sx11c.html" rel=precedes>next</a>
<a href="sx11.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
